BulkyWeb/Areas/Admin/Controllers/CompanyController.cs
using Microsoft.AspNetCore.Mvc;
using Bulky.Models;
using Bulky.DataAccess.Repository.IRepository;
// using Bulky.Utils;

namespace BulkyWeb.Areas.Admin.Controllers;

[Area("Admin")]
// [Authorize(Roles = SD.Role_Admin)]
public class CompanyController : Controller
{
    private readonly ILogger<CompanyController> _logger;
    private readonly IUnitOfWork _unitOfWork;

    public CompanyController(ILogger<CompanyController> logger, IUnitOfWork unitOfWork)
    {
         _logger = logger;
        _unitOfWork = unitOfWork;
    }

    public IActionResult Index()
    {
        List<Company> O_CompanyList = _unitOfWork.Company.GetAll().ToList();

        return View(O_CompanyList.OrderBy(b => b.Id));
    }

    public IActionResult Upsert(int? id)
    {
        if (id == null || id == 0)
        {
            //Create
            return View(new Company());

        }
        else
        {
            //Update
            Company O_Company = _unitOfWork.Company.Get(b => b.Id == id);
            return View(O_Company);
        }
    }

    [HttpPost]
    public IActionResult Upsert(Company O_Company)
    {
        if(ModelState.IsValid)
        {
            if (O_Company.Id == 0)
            {
                _unitOfWork.Company.Add(O_Company);
                TempData["success"] = "Company created successfully";
            }
            else
            {
                _unitOfWork.Company.Update(O_Company);
                TempData["success"] = "Company has been successfully Updated";
            }

            _unitOfWork.Save();
            return RedirectToAction("Index");
        }

        return View(O_Company);
    }

    #region API CALLS

    [HttpGet]
    public IActionResult GetAll()
    {
        List<Company> O_Company = _unitOfWork.Company.GetAll().ToList();
        return Json(
            new {
                data = O_Company
            }
        );
    }

    [HttpDelete]
    public IActionResult Delete(int? id)
    {
        if (id is not null)
        {
            Company companyToBeDeleted = _unitOfWork.Company.Get(b => b.Id == id);

            if ( companyToBeDeleted is null )
            {
                return Json(
                    new {
                        success = false,
                        message = "Error while deleting"
                    });
            }

            _unitOfWork.Company.Remove(companyToBeDeleted);
            _unitOfWork.Save();
            return Json(
                new {
                    success = true,
                    message = "Book has been deleted successfully"
                });

        }
        return Json(
            new {
                success = false,
                message = "You have not provide a valid book product id"
            });
    }

    #endregion
}

BulkyWeb/Areas/Admin/Views/Company/Index.cshtml
<div class="card shadow border-0 mt-4">
    <div class="card-header bg-secondary bg-gradient ml-0 py-3">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">List of Companies</h2>
            </div>
        </div>
    </div>

    <div class="card-body p-4">
        <div class="row pb-3">
            <div class="col-12 text-end">
                <a asp-controller="Company" asp-action="Upsert" class="btn btn-primary">
                    Add new Company<span>&nbsp;&nbsp;</span><i class="bi bi-plus-square-dotted"></i>
                </a>
            </div>
        </div>
    <table id="tblData" class="table table-bordered table-striped p-2" style="width:100%">
        <thead>
            <tr>
                <th>
                    <h5><b>Name</b></h5>
                </th>
                <th>
                    <h5><b>Address</b></h5>
                </th>
                <th>
                    <h5><b>City</b></h5>
                </th>
                <th>
                    <h5><b>State</b></h5>
                </th>
                <th>
                    <h5><b>Phone Number</b></h5>
                </th>
                <th>
                    <h5><b>Actions</b></h5>
                </th>
            </tr>
        </thead>

    </table>
</div>

@section Scripts {
    <script src="~/js/company.js"></script>
}

BulkyWeb/Areas/Admin/Views/Company/Upsert.cshtml
@model Company


<div class="card shadow border-0 mt-4">
    <div class="card-header bg-secondary bg-gradient ml-0 py-3">
        <input asp-for="Id" hidden />
        <div class="row">
            <div class="col-12 text-center">
                @if(@Model.Id != 0)
                {
                    <h2 class="text-white py-2">Update Company</h2>
                }
                else
                {
                    <h2 class="text-white py-2">Create Company</h2>
                }
            </div>
        </div>
    </div>
    <div class="card-body p-4">
        <form method="post" class="row" enctype="multipart/form-data">
            <div class="row">
                <div class="col-12">
                    <div class="border p-3">
                        <div class="row pb-2">
                            <!-- <hr/> -->
                        </div>

                        <div class="form-floating py-2 col-12">
                            <input asp-for="Name" class="form-control border-0 shadow" placeholder="Name"></input>
                            <label asp-for="Name" class="ms-2">Name</label>
                            <span asp-validation-for="Name" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="PhoneNumber" class="form-control border-0 shadow" placeholder="+576076346789"></input>
                            <label asp-for="PhoneNumber" class="ms-2">Phone Number</label>
                            <span asp-validation-for="PhoneNumber" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="StreetAddress" class="form-control border-0 shadow" placeholder="Street 90 Avenue 24"></input>
                            <label asp-for="StreetAddress" class="ms-2">Street Address</label>
                            <span asp-validation-for="StreetAddress" class="text-danger"></span>
                        </div>

                        <div class="form-floating py-2 col-12">
                            <input asp-for="City" class="form-control border-0 shadow" placeholder="City"></input>
                            <label asp-for="City" class="ms-2">City</label>
                            <span asp-validation-for="City" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="State" class="form-control border-0 shadow" placeholder="State"></input>
                            <label asp-for="State" class="ms-2">State</label>
                            <span asp-validation-for="State" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="PostalCode" class="form-control border-0 shadow" placeholder="Postal Code"></input>
                            <label asp-for="PostalCode" class="ms-2">Postal Code</label>
                            <span asp-validation-for="PostalCode" class="text-danger"></span>
                        </div>


                        <div class="row pt-2">
                            <div class="col-md-6 col-md-3">
                                @if (Model.Id != 0 )
                                {
                                    <button type="submit" class="btn btn-primary" style="width:120px">Update</button>
                                }
                                else
                                {
                                    <button type="submit" class="btn btn-primary" style="width:120px">Create</button>
                                }
                                    <a asp-controller="Company" asp-action="Index" class="btn btn-secondary" >Back to Company List</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>


@section scripts {
    @{
        <partial name="_ValidationScriptsPartial" />
    }
    <script>
    tinymce.init({
      selector: 'textarea',
      plugins: 'anchor autolink charmap codesample lists table visualblocks wordcount checklist mediaembed casechange export formatpainter pageembed permanentpen powerpaste advtable advcode editimage tableofcontents footnotes mergetags autocorrect inlinecss',
      toolbar: 'undo redo | blocks fontfamily fontsize | bold italic underline strikethrough | align lineheight | checklist numlist bullist indent outdent',
    });
  </script>

}